<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Custom_pagination {

	public $total_pages;
	public $targetpage;
	public $limit;
	public $start;
	public $page;
	public $style;
	public $prev;
	public $next;
	public $lastpage;
	public $lpm1;
	public $pagination;
	public $adjacents = 3;
	
	function __construct() {
		
	}
	
        public function show_pagination($total_pages="",$targetpage="",$limit="",$page="")
        {
			$this->total_pages = $total_pages;
			$this->targetpage = $targetpage;
			$this->limit = $limit;
			$this->page = $page;
			
			if($page){ 
				$this->start = ($this->page - 1) * $this->limit; 			//first item to display on this page
			}else{
				$this->start = 0;	
			}
			
			return array('start' => $this->start, 'limit' => $this->limit);
			
        }
		
		public function define_pagination()
		{
			if ($this->page == 0){ $this->page = 1;}				//if no page var is given, default to 1.
			$this->prev = $this->page - 1;							//previous page is page - 1
			$this->next = $this->page + 1;							//next page is page + 1
			$this->lastpage = ceil($this->total_pages/$this->limit);		//lastpage is = total pages / items per page, rounded up.
			$this->lpm1 = $this->lastpage - 1;
			
			$this->pagination="<style>div.pagination {
									padding: 3px;
									margin: 3px;
								}

								div.pagination a {
									padding: 2px 5px 2px 5px;
									margin: 2px;
									border: 1px solid #AAAADD;
									
									text-decoration: none; 
									color: #000099;
								}
								div.pagination a:hover, div.pagination a:active {
									border: 1px solid #000099;

									color: #000;
								}
								div.pagination span.current {
								padding: 2px 5px 2px 5px;
								margin: 2px;
									border: 1px solid #000099;
									
									font-weight: bold;
									background-color: #000099;
									color: #FFF;
								}
								div.pagination span.disabled {
									padding: 2px 5px 2px 5px;
									margin: 2px;
									border: 1px solid #EEE;
								
									color: #DDD;
								}</style>";
			if($this->lastpage > 1)
			{	
				$this->pagination .= "<div class=\"pagination\">";
				//previous button
				if ($this->page > 1) 
					$this->pagination.= "<a href=\"$this->targetpage$this->prev\">«</a>" ;
				else
					$this->pagination.= "<span class=\"disabled\">«</span>";	
				
				//pages	
				if ($this->lastpage < 7 + ($this->adjacents * 2))	//not enough pages to bother breaking it up
				{	
					for ($counter = 1; $counter <= $this->lastpage; $counter++)
					{
						if ($counter == $this->page)
							$this->pagination.= "<span class=\"current\">$counter</span>";
						else
							$this->pagination.= "<a href=\"$this->targetpage$counter\">$counter</a>";					
					}
				}
				elseif($this->lastpage > 5 + ($this->adjacents * 2))	//enough pages to hide some
				{
					//close to beginning; only hide later pages
					if($this->page < 1 + ($this->adjacents * 2))		
					{
						for ($counter = 1; $counter < 4 + ($this->adjacents * 2); $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage$counter\">$counter</a>";					
						}
						$this->pagination.= "...";
						$this->pagination.= "<a href=\"$this->targetpage$this->lpm1\">$this->lpm1</a>";
						$this->pagination.= "<a href=\"$this->targetpage$this->lastpage\">$this->lastpage</a>";		
					}
					//in middle; hide some front and some back
					elseif($this->lastpage - ($this->adjacents * 2) > $this->page && $this->page > ($this->adjacents * 2))
					{
						$this->pagination.= "<a href=\"$this->targetpage1\">1</a>";
						$this->pagination.= "<a href=\"$this->targetpage2\">2</a>";
						$this->pagination.= "...";
						for ($counter = $this->page - $this->adjacents; $counter <= $this->page + $this->adjacents; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage$counter\">$counter</a>";					
						}
						$this->pagination.= "...";
						$this->pagination.= "<a href=\"$this->targetpage$this->lpm1\">$this->lpm1</a>";
						$this->pagination.= "<a href=\"$this->targetpage$this->lastpage\">$this->lastpage</a>";		
					}
					//close to end; only hide early pages
					else
					{
						$this->pagination.= "<a href=\"$this->targetpage1\">1</a>";
						$this->pagination.= "<a href=\"$this->targetpage2\">2</a>";
						$this->pagination.= "...";
						for ($counter = $this->lastpage - (2 + ($this->adjacents * 2)); $counter <= $this->lastpage; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage$counter\">$counter</a>";					
						}
					}
				}
				
				//next button
				if ($this->page < $counter - 1) 
					$this->pagination.= "<a href=\"$this->targetpage$this->next\">»</a>";
				else
					$this->pagination.= "<span class=\"disabled\">»</span>";
				$this->pagination.= "</div>\n";		
			}
			return $this->pagination;
		}
		
		
		public function define_pagination1()
		{
			if ($this->page == 0){ $this->page = 1;}				//if no page var is given, default to 1.
			$this->prev = $this->page - 1;							//previous page is page - 1
			$this->next = $this->page + 1;							//next page is page + 1
			$this->lastpage = ceil($this->total_pages/$this->limit);		//lastpage is = total pages / items per page, rounded up.
			$this->lpm1 = $this->lastpage - 1;
			
			$this->pagination="<style>div.pagination {
									padding: 3px;
									margin: 3px;
								}

								div.pagination a {
									padding: 2px 5px 2px 5px;
									margin: 2px;
									border: 1px solid #AAAADD;
									
									text-decoration: none; /* no underline */
									color: #000099;
								}
								div.pagination a:hover, div.pagination a:active {
									border: 1px solid #000099;

									color: #000;
								}
								div.pagination span.current {
								padding: 2px 5px 2px 5px;
								margin: 2px;
									border: 1px solid #000099;
									
									font-weight: bold;
									background-color: #000099;
									color: #FFF;
								}
								div.pagination span.disabled {
									padding: 2px 5px 2px 5px;
									margin: 2px;
									border: 1px solid #EEE;
								
									color: #DDD;
								}</style>";
			if($this->lastpage > 1)
			{	
				$this->pagination .= "<div class=\"pagination\">";
				//previous button
				if ($this->page > 1) 
					$this->pagination.= "<a href=\"$this->targetpage&page=$this->prev\">«</a>" ;
				else
					$this->pagination.= "<span class=\"disabled\">«</span>";	
				
				//pages	
				if ($this->lastpage < 7 + ($this->adjacents * 2))	//not enough pages to bother breaking it up
				{	
					for ($counter = 1; $counter <= $this->lastpage; $counter++)
					{
						if ($counter == $this->page)
							$this->pagination.= "<span class=\"current\">$counter</span>";
						else
							$this->pagination.= "<a href=\"$this->targetpage&page=$counter\">$counter</a>";					
					}
				}
				elseif($this->lastpage > 5 + ($this->adjacents * 2))	//enough pages to hide some
				{
					//close to beginning; only hide later pages
					if($this->page < 1 + ($this->adjacents * 2))		
					{
						for ($counter = 1; $counter < 4 + ($this->adjacents * 2); $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage&page=$counter\">$counter</a>";					
						}
						$this->pagination.= "...";
						$this->pagination.= "<a href=\"$this->targetpage&page=$this->lpm1\">$this->lpm1</a>";
						$this->pagination.= "<a href=\"$this->targetpage&page=$this->lastpage\">$this->lastpage</a>";		
					}
					//in middle; hide some front and some back
					elseif($this->lastpage - ($this->adjacents * 2) > $this->page && $this->page > ($this->adjacents * 2))
					{
						$this->pagination.= "<a href=\"$this->targetpage1\">1</a>";
						$this->pagination.= "<a href=\"$this->targetpage2\">2</a>";
						$this->pagination.= "...";
						for ($counter = $this->page - $this->adjacents; $counter <= $this->page + $this->adjacents; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage&page=$counter\">$counter</a>";					
						}
						$this->pagination.= "...";
						$this->pagination.= "<a href=\"$this->targetpage&page=$this->lpm1\">$this->lpm1</a>";
						$this->pagination.= "<a href=\"$this->targetpage&page=$this->lastpage\">$this->lastpage</a>";		
					}
					//close to end; only hide early pages
					else
					{
						$this->pagination.= "<a href=\"$this->targetpage1\">1</a>";
						$this->pagination.= "<a href=\"$this->targetpage2\">2</a>";
						$this->pagination.= "...";
						for ($counter = $this->lastpage - (2 + ($this->adjacents * 2)); $counter <= $this->lastpage; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<span class=\"current\">$counter</span>";
							else
								$this->pagination.= "<a href=\"$this->targetpage&page=$counter\">$counter</a>";					
						}
					}
				}
				
				//next button
				if ($this->page < $counter - 1) 
					$this->pagination.= "<a href=\"$this->targetpage&page=$this->next\">»</a>";
				else
					$this->pagination.= "<span class=\"disabled\">»</span>";
				$this->pagination.= "</div>\n";		
			}
			return $this->pagination;
		}
		
		public function define_pagination2()
		{
			if ($this->page == 0){ $this->page = 1;}				//if no page var is given, default to 1.
			$this->prev = $this->page - 1;							//previous page is page - 1
			$this->next = $this->page + 1;							//next page is page + 1
			$this->lastpage = ceil($this->total_pages/$this->limit);		//lastpage is = total pages / items per page, rounded up.
			$this->lpm1 = $this->lastpage - 1;
			
			if($this->lastpage > 1)
			{	
				$this->pagination .= "<ul class=\"pagination pagination-sm pull-right\">";
				//previous button
				if ($this->page > 1) 
					$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$this->prev\">«</a></li>" ;
				else
					$this->pagination.= "<li class=\"disabled\" data-page=\"\"><a href=\"javascript:void(0);\">«</a></li>";	
				
				//pages	
				if ($this->lastpage < 7 + ($this->adjacents * 2))	//not enough pages to bother breaking it up
				{	
					for ($counter = 1; $counter <= $this->lastpage; $counter++)
					{
						if ($counter == $this->page)
							$this->pagination.= "<li class=\"active\"><a href=\"javascript:void(0);\" data-page=\"\">$counter</a></li>";
						else
							$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$counter\">$counter</a></li>";					
					}
				}
				elseif($this->lastpage > 5 + ($this->adjacents * 2))	//enough pages to hide some
				{
					//close to beginning; only hide later pages
					if($this->page < 1 + ($this->adjacents * 2))		
					{
						for ($counter = 1; $counter < 4 + ($this->adjacents * 2); $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<li class=\"active\"><a href=\"javascript:void(0);\" data-page=\"\">$counter</a></li>";
							else
								$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$counter\">$counter</a></li>";						
						}
						$this->pagination.= "<li><a>...</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$this->lpm1\">$this->lpm1</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$this->lastpage\">$this->lastpage</a></li>";		
					}
					//in middle; hide some front and some back
					elseif($this->lastpage - ($this->adjacents * 2) > $this->page && $this->page > ($this->adjacents * 2))
					{
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"1\">1</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"2\">2</a></li>";
						$this->pagination.= "<li><a>...</a></li>";
						for ($counter = $this->page - $this->adjacents; $counter <= $this->page + $this->adjacents; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<li class=\"active\"><a href=\"javascript:void(0);\" data-page=\"\">$counter</a></li>";
							else
								$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$counter\">$counter</a></li>";					
						}
						$this->pagination.= "<li><a>...</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$this->lpm1\">$this->lpm1</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$this->lastpage\">$this->lastpage</a></li>";		
					}
					//close to end; only hide early pages
					else
					{
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"1\">1</a></li>";
						$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"2\">2</a></li>";
						$this->pagination.= "<li><a>...</a></li>";
						for ($counter = $this->lastpage - (2 + ($this->adjacents * 2)); $counter <= $this->lastpage; $counter++)
						{
							if ($counter == $this->page)
								$this->pagination.= "<li class=\"active\"><a href=\"javascript:void(0);\" data-page=\"\">$counter</a></li>";
							else
								$this->pagination.= "<li ><a href=\"javascript:void(0);\" data-page=\"$counter\">$counter</a></li>";					
						}
					}
				}
				
				//next button
				if ($this->page < $counter - 1) 
					$this->pagination.= "<li class=\"\" ><a href=\"javascript:void(0);\" data-page=\"$this->next\">»</a></li>";
				else
					$this->pagination.= "<li class=\"disabled\" ><a href=\"javascript:void(0);\" data-page=\"\">»</a></li>";
				$this->pagination.= "</ul>\n";		
			}
			return $this->pagination;
		}
}
?>