<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

class Admin extends MX_Controller {
	
	function __construct() {

		parent::__construct();
		check_login();
		$this->load->model(array('general_model'));
    }
	
	public function index($rowno=0,$sortBy="id",$order="desc"){	
		$data =array();
		$this->session->unset_userdata('search');
		$this->session->unset_userdata('sortBy');
		$this->session->unset_userdata('order');

		/*Search form start*/
	    $search_text = ""; $tbl_name = 'users';
	    if($this->input->post('search') != NULL ){
	    	$search_text = $this->input->post('search');
	      	$this->session->set_userdata(array("search"=>$search_text));
	    }else{
	    	if($this->session->userdata('search') != NULL){
	        	$search_text = $this->session->userdata('search');
	      	}
	    }

	    if($this->input->post('reset') == 'RESET'){
			$this->session->unset_userdata('search');
			$search_text = '';
			redirect('admin/user');
		}
		/*Search form end*/

		$rowperpage = 10;

		// Row position
	    if($rowno != 0){
	      $rowno = ($rowno-1) * $rowperpage;
	    }
 		
	    // Set session
	    if($this->uri->segment('4') != NULL ){
			$this->session->set_userdata(array("sortBy"=>$sortBy));
			$this->session->set_userdata(array("order"=>$order));
		}else{
			if($this->session->userdata('sortBy') != NULL){
				$sortBy = $this->session->userdata('sortBy');
				$order = $this->session->userdata('order');
			}
		}
		//echo $search_from.' '.$search_to;
	    // Total records count
	    $allcount = $this->general_model->getrecordCount($search_text,$tbl_name);

	    // Get records
	    $posts_record = $this->general_model->getData($rowno,$rowperpage,$sortBy,$order,$search_text,$tbl_name);
	 
	    // Pagination Configuration
	    $config['base_url'] = base_url().'admin/user/index';
	    $config['use_page_numbers'] = TRUE;
	    $config['total_rows'] = $allcount;
	    $config['per_page'] = $rowperpage;
	    $config['full_tag_open'] = '<div><ul class="pagination">';
		$config['full_tag_close'] = '</ul></div><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = 'Next &rarr;';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '&larr; Previous';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$config['anchor_class'] = 'follow_link';

	    // Initialize
	    $this->pagination->initialize($config);

	    /* Excel Download start*/
	 	// create file name
	 	if($this->input->post('export') == 'Export Data'){

	 		$fileName = "user". date("Y-m-d-H-i-s").".xlsx"; 
			$spreadsheet = new Spreadsheet();
	        $sheet = $spreadsheet->getActiveSheet();
	       	$sheet->setCellValue('A1', 'User Name');
	        $sheet->setCellValue('B1', 'Email');
	        $sheet->setCellValue('C1', 'Phone Number');
	                   
	        $rows = 2;
	        foreach ($posts_record as $val){
	            $sheet->setCellValue('A' . $rows, $val['fullname']);
	            $sheet->setCellValue('B' . $rows, $val['email']);
	            $sheet->setCellValue('C' . $rows, $val['ph_number']);
	            $rows++;
	        } 
	        $writer = new Xlsx($spreadsheet);
			$writer->save("uploads/excel/".$fileName);
			header("Content-Type: application/vnd.ms-excel");
	        redirect(base_url()."/uploads/excel/".$fileName); 
        }
        /* Excel Download end*/

	    $data['pagination'] = $this->pagination->create_links();
	    $data['user'] = $posts_record;
	    $data['row'] = $rowno;
	    $data['order'] = $order;
	    $data['search'] = $search_text;

		//$data['products']=$this->general_model->get_where_all('products',array('status !='=>0));
		
		$this->layouts->set_title('User List');
		$this->layouts->header_include('',false);
		$this->layouts->footer_include('',true);
		$this->layouts->view('admin_index',$data);
	}
	
	public function add(){
		$data =array();
		$this->form_validation->set_rules('fullname', 'Name', 'trim|required');
		$this->form_validation->set_rules('display_name', 'Display Name', 'trim|required');
		$this->form_validation->set_rules('email', 'Email', 'trim|required');
		$this->form_validation->set_rules('password', 'Password', 'trim|required');

		if(isset($_POST) && ! empty($_POST)){
			if($this->form_validation->run() == false){
			    $data['message'] = error_message(validation_errors());
			}else{
				if($_FILES['user_image']['name'] !=''){

					$array = explode('.', $_FILES['user_image']['name']);
					$extension = end($array);
					$new_file_name = time().'.'.$extension;

					$config['upload_path'] 	 = './uploads/user/';
					$config['allowed_types'] = 'gif|jpg|png|jpeg';
					$config['file_name']     = $new_file_name;
					$this->load->library('upload', $config);
					$this->upload->initialize($config);

					if(!$this->upload->do_upload('user_image')) {
						$error = array('error' => $this->upload->display_errors()); 
						//echo '<pre>'; print_r($error); echo '</pre>'; exit;
					}else{ 
						$data = array('upload_data' => $this->upload->data()); 
						$user_data['user_image'] = $new_file_name;
					} 
				}

				$user_data['fullname'] = $this->input->post('fullname');
				$user_data['display_name'] = $this->input->post('display_name');
				$user_data['password'] = md5($this->input->post('password'));
				$user_data['email'] = $this->input->post('email');
				$user_data['ph_number'] = $this->input->post('ph_number');
				$user_data['birthday'] = $this->input->post('birthday');
				$user_data['status'] = $this->input->post('status');
			
				$ress=$this->general_model->insert("users",$user_data);
				if($ress){
					$this->session->set_flashdata('msg', succes_message('User has been successfully inserted'));
					redirect('admin/user');	
				}
	        }
		}
		
		$this->layouts->set_title('Add User');
		$this->layouts->header_include('',false);
		$this->layouts->footer_include('',false);
		$this->layouts->view('admin_add',$data);
	}
	
	
	public function edit($id=""){
		$data =array();
		$data['user_data']=$this->general_model->get_row('users',array('id'=>$id));
		if(isset($_POST) && ! empty($_POST)){

			if($_FILES['user_image']['name'] !=''){

				$array = explode('.', $_FILES['user_image']['name']);
				$extension = end($array);
				$new_file_name = time().'.'.$extension;

				$config['upload_path'] 	 = './uploads/user/';
				$config['allowed_types'] = 'gif|jpg|png|jpeg';
				$config['file_name']     = $new_file_name;
				$this->load->library('upload', $config);
				$this->upload->initialize($config);

				if(!$this->upload->do_upload('user_image')) {
					$error = array('error' => $this->upload->display_errors()); 
					//echo '<pre>'; print_r($error); echo '</pre>'; exit;
				}else{ 
					if($data['user_data']['user_image'] !=''){
						unlink("uploads/user/".$data['user_data']['user_image']);	
					}
					$data = array('upload_data' => $this->upload->data()); 
					$user_data['user_image'] = $new_file_name;
				} 
			}

			$user_data['fullname'] = $this->input->post('fullname');
			$user_data['display_name'] = $this->input->post('display_name');
			$user_data['email'] = $this->input->post('email');
			$user_data['ph_number'] = $this->input->post('ph_number');
			$user_data['birthday'] = $this->input->post('birthday');
			$user_data['status'] = $this->input->post('status');
		
			$this->general_model->update("users",$user_data,array('id'=>$id));
        	$this->session->set_flashdata('msg', succes_message('User has been successfully updated'));
			redirect('admin/user');	
		}
		
		$data['user_data']=$this->general_model->get_row('users',array('id'=>$id));
		
		$this->layouts->set_title('Edit User');
		$this->layouts->header_include('',false);
		$this->layouts->footer_include('',false);
		$this->layouts->view('admin_edit',$data);
	}

	public function detail($id='')
	{	
		$data =array();
		$data['user_data']=$this->general_model->get_row('users',array('id'=>$id));
		$this->load->library('Layouts');
		$this->layouts->set_title('Users Detail');
		$this->layouts->header_include('',false);
		$this->layouts->footer_include('',true);
		$this->layouts->view('admin_view',$data);
	}
	
	public function delete($id){
		
		$this->general_model->update("users",array('status'=>0),array('id'=>$id));
		$this->session->set_flashdata('msg', succes_message('User has been successfully deleted'));
		redirect('admin/user');
	}

	public function saveInfo(){
		$data =array();

		if(!empty($_POST)){
			$user['user_id'] = $this->input->post('userid');
			$user['address_type'] = $this->input->post('address_type');
			$user['city'] = $this->input->post('city');
			$user['location'] = $this->input->post('location');
			$user['zip'] = $this->input->post('zip');
			$user['landmark'] = $this->input->post('landmark');
			$user['address'] = $this->input->post('address');
			$user['state'] = $this->input->post('state');
			
			$user_data=$this->general_model->get_row('user_address',array('user_id'=>$this->input->post('userid'),'address_type'=>$this->input->post('address_type')));

			if(count($user_data) > 0){
				$data['ack'] = 2;
			}else{
				$ress=$this->general_model->insert("user_address",$user);
				if($ress){
					$data['ack'] = 1;
				}else{
					$data['ack'] = 0;
				}
			}
		}

		echo json_encode($data); exit;
	}

	public function getInfo(){
		
		if(!empty($_POST)){
			$user_data=$this->general_model->get_row('user_address',array('id'=>$this->input->post('id'),'user_id'=>$this->input->post('userid')));
			if($user_data){
				$user_data['ack'] = 1;
			}
		}
		echo json_encode($user_data); exit;
	}

	public function editInfo(){
		$data =array();

		if(!empty($_POST)){
			$user['user_id'] = $this->input->post('userid');
			//$user['address_type'] = $this->input->post('address_type');
			$user['city'] = $this->input->post('city');
			$user['location'] = $this->input->post('location');
			$user['zip'] = $this->input->post('zip');
			$user['landmark'] = $this->input->post('landmark');
			
			$ress=$this->general_model->update("user_address",$user,array('id'=>$this->input->post('id'),'user_id'=>$this->input->post('userid')));
			if($ress){
				$data['ack'] = 1;
			}else{
				$data['ack'] = 0;
			}
		}

		echo json_encode($data); exit;
	}

	public function check_email(){
	    $e=$this->input->post('email_id');
		$a=$this->general_model->get_row('users',array('email'=>$e));
		if($a){
			echo 1;
		}else{
			echo 0;
		}
	}
	
	public function check_phone(){
	    $e=$this->input->post('uphone');
		$a=$this->general_model->get_row('users',array('number'=>$e));
		if($a){
			echo 1;
		}else{
			echo 0;
		}
	}
}