<?php
if (! defined('BASEPATH')) exit('No direct script access');

class General_model extends CI_Model 
{
	function __construct()
	{
        parent::__construct();
		$this->load->database();
	}
	
	public function insert($tbl_name,$data)                 //used for insert data into database...

	{

		$this->db->insert($tbl_name,$data);

		$insert_id = $this->db->insert_id();
		return  $insert_id;

	}


	public function update($tbl_name,$data,$clause)        //used for update data with clause into database...

	{

		$res=$this->db->update($tbl_name, $data,$clause); 
		return $res;

	}


	public function get_row($tbl_name,$data,$field='')        //used for fetch a single row from database...
	{
		if($field!=''){
			$this->db->select($field);
		}

		$qry=$this->db->get_where($tbl_name,$data);
		$result = $qry->row_array();
		$qry->free_result();
		return $result;

	}
	public function get_where_all($tbl_name,$data,$field='',$order='',$limit='')  //used for fetching data with where condition...
	{
		if($field!=''){
			$qry=$this->db->select($field);
		}
		
		if($order!=''){
			$qry=$this->db->order_by($order[0],$order[1]);
		}
		
		// if($limit!=''){
		// 	$qry=$this->db->limit($limit[0],$limit[1]);
		// }

		if($limit!=''){
			$qry=$this->db->limit($limit[0]);
		}
		
				
		$qry=$this->db->get_where($tbl_name,$data);
		
		//echo $this->db->last_query(); exit;
		$result = $qry->result_array();
		$qry->free_result();
		return $result;

	}

	public function get_all($table_name,$field='',$order='',$limit=''){
		if($field!=''){
			$qry=$this->db->select($field);
		}
		
		if($order!=''){

			$qry=$this->db->order_by($order[0],$order[1]);
		}
		
		if($limit!=''){
			$qry=$this->db->limit($limit[0],$limit[1]);
		}
		$qry = $this->db->get($table_name);
		$result = $qry->result_array();
		$qry->free_result();
		return $result;
	}
	
	

	public function delete($tbl_name,$clause){

		$res = $this->db->delete($tbl_name,$clause);
		return $res;
	}
	
	public function count_row($tbl_name,$clause,$select){
		$query_count = $this->db->query("SELECT COUNT(".$select.") as cnt FROM ".$tbl_name." WHERE ".$clause);
		$cnt = $query_count->row_array();
		$result = $cnt['cnt'];
		$query_count->free_result();
		return $result;
	}

	public function get_first_row($tbl_name){
		$query = $this->db->query("SELECT * from ".$tbl_name."");

		if ($query->num_rows() > 0)
		{
		   $row = $query->row_array(); 
		   return $row;
		}
	}
	public function distinctattribute($tbl_name,$clause){
		$query = $this->db->query("SELECT * FROM `product_attribute` WHERE `pid`=$clause GROUP BY `colorid`");
		$result = $query->result_array();
		return $result;
	}
    public function getrecordCount($search = '',$tbl_name='') {

    	$where = '';
		$where .='status != "0"';

    	$this->db->select('count(*) as allcount');
      	$this->db->from($tbl_name);

      	$this->db->where($where);

      	if($search != ''){
      		if($tbl_name == 'products'){
      			$this->db->like('product_name', $search);
      		}elseif($tbl_name == 'users'){
      			$this->db->like('fullname', $search);
      			$this->db->or_like('email', $search);
      			$this->db->or_like('ph_number', $search);
      		}elseif($tbl_name == 'payments'){
      			$this->db->like('transaction_id', $search);
      		}
	    }

      	$query = $this->db->get();

      	//echo $this->db->last_query();
      	$result = $query->result_array();
      
      	return $result[0]['allcount'];
    }

    public function getData($rowno,$rowperpage,$sortBy,$order,$search="",$tbl_name=''){
		$where = '';
		$where .='status != "0"';

		$this->db->select('*');
		$this->db->from($tbl_name);

		if($search != ''){
	        if($tbl_name == 'products'){
      			$this->db->like('product_name', $search);
      		}elseif($tbl_name == 'users'){
      			$this->db->like('fullname', $search);
      			$this->db->or_like('email', $search);
      			$this->db->or_like('ph_number', $search);
      		}elseif($tbl_name == 'payments'){
      			$this->db->like('transaction_id', $search);
      		}
	    }

	    $this->db->where($where);
		$this->db->order_by($sortBy, $order);
        $this->db->limit($rowperpage, $rowno);  
		$query = $this->db->get();
       	//echo $this->db->last_query();
		return $query->result_array();
	}

	/*Order section start*/
	public function getorderrecordCount($search = '',$search_from='',$search_to='',$tbl_name='') {
		$searchdate = $search_from !='' ? date('Y-m-d',strtotime($search_from)) : '';
		$searchtodate = $search_to !='' ? date('Y-m-d',strtotime($search_to)) : '';

		$where = '';
		$where .="status != 0";
    	$query = "SELECT * FROM orders";

		if($search !='' && $searchdate =='' && $searchtodate =='')
		{
			$query .= " 
			WHERE order_name LIKE '%$search%'
			";
		}
		if($search =='' && $searchdate !='' && $searchtodate ==''){
			$query .= " 
			WHERE created_at = '$searchdate'
			";
		}elseif($search =='' && $searchdate =='' && $searchtodate !=''){
			$query .= " 
			WHERE created_at = '$searchtodate'
			";
		}elseif($search !='' && $searchdate !='' && $searchtodate !=''){
			$query .= " 
			WHERE order_name LIKE '%$search%' AND created_at >= '$searchdate' AND created_at <= '$searchtodate'
			";
		}elseif($search !='' && $searchdate !='' && $searchtodate ==''){
			$query .= " 
			WHERE order_name LIKE '%$search%' AND created_at = '$searchdate'
			";
		}elseif($search !='' && $searchdate =='' && $searchtodate !=''){
			$query .= " 
			WHERE order_name LIKE '%$search%' AND created_at = '$searchtodate'
			";
		}elseif($search =='' && $searchdate !='' && $searchtodate !=''){
			$query .= " 
			WHERE created_at >= '$searchdate' AND created_at <= '$searchtodate'
			";
		}
		$query .= " GROUP BY id ORDER BY id DESC";
		
		//echo $query;
		$data = $this->db->query($query);
	  	return $data->num_rows();
    }

    public function getorderData($rowno,$rowperpage,$sortBy,$order,$search="",$search_from="",$search_to="",$tbl_name=''){
    	//echo $search_from.' '.$search_to;
		$where = '';
		$where .="status != 0";
		$searchdate = $search_from !='' ? date('Y-m-d',strtotime($search_from)) : '';
		$searchtodate = $search_to !='' ? date('Y-m-d',strtotime($search_to)) : '';

		$this->db->select('*');
		$this->db->from($tbl_name);

		if($search != '' && $searchdate =='' && $searchtodate ==''){
	        $this->db->like('order_name', $search);
	    }
	    if($search == '' && $searchdate !='' && $searchtodate ==''){
			$this->db->where('created_at', $searchdate);
		}elseif($search == '' && $searchdate =='' && $searchtodate !=''){
			$this->db->where('created_at', $searchtodate);
		}elseif($search != '' && $searchdate !='' && $searchtodate !=''){
			$this->db->like('order_name', $search);
			$this->db->where('created_at >=', $searchdate);
			$this->db->where('created_at <=', $searchtodate);
		}elseif($search != '' && $searchdate !='' && $searchtodate ==''){
			$this->db->like('order_name', $search);
			$this->db->where('created_at', $searchdate);
		}elseif($search != '' && $searchdate =='' && $searchtodate !=''){
			$this->db->like('order_name', $search);
			$this->db->where('created_at', $searchtodate);
		}elseif($search == '' && $searchdate !='' && $searchtodate !=''){
			$this->db->where('created_at >=', $searchdate);
			$this->db->where('created_at <=', $searchtodate);
		}
	    $this->db->where($where);
		$this->db->order_by($sortBy, $order);
        $this->db->limit($rowperpage, $rowno);  
		$query = $this->db->get();
       	//echo $this->db->last_query();
		return $query->result_array();
	}
	/*Order section end*/
    
    /*Frontend order and transaction pagination start*/
    public function getrecordCount1($id = '',$tbl_name='') {

    	$where = '';
    	$where .="user_id = ".$id;

    	$this->db->select('count(*) as allcount');
      	$this->db->from($tbl_name);

      	$this->db->where($where);

      	$query = $this->db->get();

      	//echo $this->db->last_query();
      	$result = $query->result_array();
      
      	return $result[0]['allcount'];
    }
    
    public function getData1($rowno,$rowperpage,$sortBy,$order,$id,$tbl_name=''){
		$where = '';
		$where .="user_id = ".$id;

		$this->db->select('*');
		$this->db->from($tbl_name);

	    $this->db->where($where);
		$this->db->order_by($sortBy, $order);
        $this->db->limit($rowperpage, $rowno);  
		$query = $this->db->get();
       	//echo $this->db->last_query();
		return $query->result_array();
	}
	
    /*end*/
    
	public function getSearchProductbyvalue($search_product){
		$where = '';
	
		if($search_product !=''){
			$where .= "products.product_name LIKE '%$search_product%'";
			$where .= ' AND ';
		}
		
		$where .="products.status = 1";
		
		$sql = "SELECT DISTINCT products.* FROM `products` LEFT JOIN gallery ON gallery.product_id=products.id WHERE " . $where ." ORDER BY products.product_name ASC" ;
		//echo $sql;
		//exit;
		return $this->db->query($sql)->result_array();
	}

	public function getcategorywishproduct($category){
		//echo $category;
		$where = '';
		$where .="status = 1";

		$this->db->select('*');
		$this->db->from('products');

		if($category != ''){
	        $this->db->where('category_id', $category); 
	    }

	    $this->db->where($where);
		$this->db->order_by('id', desc);
        //$this->db->limit($rowperpage, $rowno);  
		$query = $this->db->get();
       	//echo $this->db->last_query();
		return $query->result_array();
	}

	function make_query($color, $size, $category, $search){
		//echo $category;exit;
		$query = "
		SELECT * FROM products
		left join product_attribute on products.id=product_attribute.pid 
		WHERE status = '1'
		";

		if(isset($category) && $category !='')
		{
			$category_filter = implode("','", $category);
			$query .= "
			AND products.category_id IN('".$category_filter."')
			";
		}

		if(isset($search) && $search !='')
		{
			$query .= " 
			AND product_name LIKE '%$search%'
			";
		}


		if(isset($color))
		{
			$color_filter = implode("','", $color);
			$query .= "
			AND product_attribute.colorid IN('".$color_filter."')
			";
		}

		if(isset($size))
		{
			$size_filter = implode("','", $size);
			$query .= "
			AND product_attribute.sizeid IN('".$size_filter."')
			";
		}
		$query .= "GROUP BY id ORDER BY id DESC";
		
		//echo $query;
		return $query;
 	}

	function count_all( $color, $size, $category, $search){

	  $query = $this->make_query( $color, $size, $category, $search);
	  $data = $this->db->query($query);
	  return $data->num_rows();
	}

 	function fetch_data($limit, $start, $color, $size, $category, $search){

		$query = $this->make_query($color, $size, $category, $search);

	  	$query .= ' LIMIT '.$start.', ' . $limit;

	  	$data = $this->db->query($query);

	  	$output = '';
	  	if($data->num_rows() > 0){
	  		
			foreach($data->result_array() as $row){
				$prourl = base_url().'product/details/'.$row['slug'];
				if($row["product_image"] !=''){
					$imgurl = base_url().'uploads/product/'.$row["product_image"];
				}else{
					$imgurl = base_url().'uploads/noimage.png';
				}
                if($row["price"] != $row["special_price"]){ 
                	
                	$price ='&#8377;'.$row["special_price"].'<del>&#8377;'. $row["price"].'</del><span>'.$row['discount'].'% Off</span>';
	            }else{ 
	            	
	                $price ='₹'.$row["price"];
	            } 
	            $prefix = ''; 
                $attributes = getproductattributeinfo($row['id']);
                $attvalue='';
                 if(!empty($attributes)){
                    foreach ($attributes as $key => $attribute) { 
                        if($attribute['qnty'] >0){
                            $attrname = attributevalue($attribute['sizeid']); 
                            $attvalue .=$prefix.$attrname['attr_value_name'];
                            $prefix = ', ';
                        }
                    }
                }
            	//echo '<pre>'; print_r($attvalue);echo '</pre>';                         
				$output .='<div class="col-xl-3 col-lg-3 col-md-6 col-sm-6 col-6"> 
                    <div class="pro-box">
                        <a href="'.$prourl.'">
                        <div class="product-img">
                            <img src="'.$imgurl.'" alt="">  
                        </div>
                        </a>
                        <div class="pro-txx innpro-tx">
                            <div class="product-name">'.$row["product_name"].'</div>
                            <div class="product-det-name">'.$row["description"].'</div>
                            <div class="pro-price">'.$price.'</div>
                            <div class="pro-size">'.$attvalue.'</div>
                        </div>
                    </div>
                </div>';
			}
	  	}else{
	   		$output = '<h3>No Data Found</h3>';
	  	}
	  	//echo $output; exit;
	  	return $output;
 	}

	function signup($tbl_name,$data){
		
		$this->db->insert($tbl_name,$data);

		$insert_id = $this->db->insert_id();
		if($insert_id){
			$this->email   		= $data['email'];
			$this->password 	=  $data['password'];
			$login = false;

			$this->db->select('users.*');
			$this->db->where('users.email',$this->email);
			$this->db->where('users.password',$this->password);
			
			$where = "(users.status ='1')";
			$this->db->where($where);

			$rs = $this->db->get('users');
			
			if ($rs->num_rows() >0 )
			{
				$row = $rs->row();
				$login = true;	
				return $row;		
			}else{
				return false;
			}
		}
	}

	function authenticateUser($data)
    {

		$this->email   		= $data['email'];
		$this->password 	=  $data['password'];
		$login = false;

		$this->db->select('users.*');
		$this->db->where('users.email',$this->email);
		$this->db->where('users.password',md5($this->password));
		
		$where = "(users.status ='1')";
		$this->db->where($where);
		$rs = $this->db->get('users');
		 
		if ($rs->num_rows() >0 )
		{
			$row = $rs->row();
			$login = true;	
			return $row;		
		}else{
			return false;
		}

		//print_r($row); exit;
		// if($login == true){
		// 	$this->session->set_userdata('member_session_id', $row->user_id);
		// 	$this->session->set_userdata('member_session_email', $row->email);
		// 	$this->session->set_userdata('member_session_name', $row->name);
		// 	return true;
		// }
    }
	
	public function commonGet($options) {

        $select = false;
        $table = false;
        $join = false;
        $order = false;
        $limit = false;
        $offset = false;
        $where = false;
        $or_where = false;
        $single = false;
        $where_not_in = false;
        $like = false;

        extract($options);

        if ($select != false)
            $this->db->select($select);

        if ($table != false)
            $this->db->from($table);

        if ($where != false)
            $this->db->where($where);

        if ($where_not_in != false) {
            foreach ($where_not_in as $key => $value) {
                if (count($value) > 0)
                    $this->db->where_not_in($key, $value);
            }
        }

        if ($like != false) {
            $this->db->like($like);
        }

        if ($or_where != false)
            $this->db->or_where($or_where);

        if ($limit != false) {

            if (!is_array($limit)) {
                $this->db->limit($limit);
            } else {
                foreach ($limit as $limitval => $offset) {
                    $this->db->limit($limitval, $offset);
                }
            }
        }


        if ($order != false) {

            foreach ($order as $key => $value) {

                if (is_array($value)) {
                    foreach ($order as $orderby => $orderval) {
                        $this->db->order_by($orderby, $orderval);
                    }
                } else {
                    $this->db->order_by($key, $value);
                }
            }
        }


        if ($join != false) {

            foreach ($join as $key => $value) {

                if (is_array($value)) {

                    if (count($value) == 3) {
                        $this->db->join($value[0], $value[1], $value[2]);
                    } else {
                        foreach ($value as $key1 => $value1) {
                            $this->db->join($key1, $value1);
                        }
                    }
                } else {
                    $this->db->join($key, $value);
                }
            }
        }


        $query = $this->db->get();

        if ($single) {
            return $query->row();
        }


        return $query->result();
    }
	
}
?>